﻿Type=Class
Version=2.02
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private Wwheelstep, newposition,WHeight,  Wtextsize, Wlblgravity, Wdelay  As Int
	Private sv As ScrollView
	Private mp As Panel
	Private overlay As ImageView
	Private Wmodule As Object
	Private lbw As Label
	Private Wtextcolor, Wlblcolor As Long
	Private Wvalues(2), WEventName As String 
	Private Wpadding As Int 
	Private tmr As Timer
	Private Wcyclic  As Boolean
End Sub

'Initializes the Wheel.
' module - the name of the activity or service which init the wheel.
' wheelstep - the height of each label in the wheel.
' cyclic - if the wheel is a loop or a line.
' EventName - the name of the wheel
' o (object) - can be the list of items or a string array or a string array of size 2 with start and end numbers.
'
' Read the displayed value in the wheel event "_Roll(value as string)", raised for any change in wheel position.
Sub initialize(module As Object, wheelstep As Int, cyclic As Boolean ,  EventName As String,  o As Object, iPadding As Int)

	Wmodule = module
	Wwheelstep = wheelstep
	Wcyclic = cyclic
	WEventName = EventName

	Wtextsize = 24
	Wdelay = 1000 
	Wtextcolor = Colors.Black
	Wlblcolor = Colors.Transparent
	Wlblgravity =  Gravity.CENTER
	Wpadding = iPadding
	If o Is List Then 
		Dim L As List
		L = o
		SetValuesByList(L)
	Else
		Dim st() As String
		st = o
		If st.Length > 2 Then
			SetValuesByArray(st)
		Else
			SetValuesByInt(st(0), st(1))
		End If
	End If
	init_view
End Sub

Private Sub SetValuesByList( List1 As List)  

	Dim n As Int
  dim i as Int 
	If Wcyclic Then
	  n = List1.Size + Wpadding * 2
		Log ("SetValuesByList" & n)
		Dim Wvalues(n) As String
		'Wvalues(0) = List1.Get(n-3)
		For i = 1 To Wpadding 'pre-padding and post-padding
		  Wvalues (Wpadding-i) = List1.Get(List1.Size - i) 
			Wvalues (n-i) = List1.Get (Wpadding - i)
		Next
		For i = 0 To List1.Size-1 'main list 
			Wvalues(i + Wpadding) = List1.Get(i)
		Next
		For i = 0 To n -1
		  Log (Wvalues(i))
		Next
		'Wvalues(n-1) = List1.Get(0)
	Else
		n = List1.Size + Wpadding * 2
		Dim Wvalues(n) As String
		For i = 0 To n - 1 - Wpadding * 2 
			Wvalues(Wpadding + i) = List1.Get(i)
		Next
		Log ("SetValuesByList" & n)
		For i = 0 To n -1
		  Log (Wvalues(i))
		Next
	End If

End Sub

Private Sub SetValuesByArray( values() As String)  
 	 
	Dim n As Int
  Dim i As Int 
	If Wcyclic Then
	  n = values.length + Wpadding * 2
		Log ("SetValuesByArray" & n)
		Dim Wvalues(n) As String
		For i = 1 To Wpadding 'pre-padding and post-padding
		  Wvalues (Wpadding-i) = values(values.length - i) 
			Wvalues (n-i) = values(i-1)
		Next
		For i = 0 To values.length-1 'main list 
			Wvalues(i + Wpadding) = values(i)
		Next
		For i = 0 To n -1
		  Log (Wvalues(i))
		Next
	Else
		n = values.length + Wpadding * 2
		Dim Wvalues(n) As String	
		For i = 0 To n - 1 - Wpadding * 2 
			Wvalues(Wpadding + i) = values(i)
		Next
		Log ("SetValuesByArray" & n)
		For i = 0 To n -1
		  Log (Wvalues(i))
		Next
	End If

End Sub

Private Sub SetValuesByInt( First As Int, Last As Int)

	Dim n As Int
  Dim i As Int 
	If Wcyclic Then
		n = Last - First + 1 + Wpadding * 2
		Log ("SetValuesByInt" & n)
		Dim Wvalues(n) As String
		For i = 1 To Wpadding 'pre-padding and post-padding
		  Wvalues (Wpadding-i) = Last - i + 1
			Wvalues (n-i) = First - i + Wpadding
		Next
		For i = 0 To Last - First 'main list 
			Wvalues(i + Wpadding) = First + i
		Next
		For i = 0 To n -1
		  Log (Wvalues(i))
		Next
	Else
		n = Last - First + 1 + Wpadding * 2
		Dim Wvalues(n) As String
		For i = 0 To n - 1 - Wpadding * 2
			Wvalues(Wpadding + i) = First + i
		Next
		Log ("SetValuesByInt" & n)
		For i = 0 To n -1
		  Log (Wvalues(i))
		Next
	End If

End Sub

Private Sub init_view
	Dim n As Int
	mp.initialize("")
	n = Wvalues.length 
	WHeight = (n+2) * Wwheelstep 
	sv.Initialize2(WHeight, "sv")
	mp.AddView(sv,0,0,-1,-1)
	sv.panel.initialize("")
	sv.Enabled = True
	' Disable Scroll Bar
	Dim r As Reflector
	r.Target = sv
	r.RunMethod2("setVerticalScrollBarEnabled", False, "java.lang.boolean")

	sv.panel.color = Wlblcolor
	putlabels( n) 
	overlay.initialize("")
	overlay.SetBackgroundImage(LoadBitmap(File.DirAssets,"Transp.png"))
	overlay.Gravity = Gravity.FILL
	mp.AddView(overlay,0,0,-1,-1)
	tmr.initialize("tmr", Wdelay)
	tmr.Enabled = False
End Sub

' Returns the Wheel object
Sub AsView As View
    Return mp
End Sub

Private Sub putlabels(n As Int)
  'remove old labels, if any, before adding more
  Dim i As Int
  Do While (sv.Panel.NumberOfViews > 0)
    sv.Panel.RemoveViewAt (0)
	Loop
	For i = 0 To n-1
		lbw.initialize("")
		lbw.Text = Wvalues(i) 
		lbw.textcolor = Wtextcolor
		lbw.color = Wlblcolor
		lbw.textsize = Wtextsize
		lbw.Gravity = Wlblgravity
		sv.panel.AddView(lbw , 0, Wwheelstep * (i+1) ,sv.panel.Width, Wwheelstep)
	Next
End Sub

Sub SetByIndex(index As Int)
	'External Index base is 1
	IntSetByIndex (index - 1)
End Sub

'Set the wheel to the required value by its index.
Private Sub IntSetByIndex(index As Int)
	newposition = (index + 1) * Wwheelstep 
	tmr.Enabled = True
End Sub

'Set the wheel to the required value by the value itself.
Sub SetByValue(Value As String)
  Dim i As Int 
	For i = Wpadding To Wvalues.Length + 1 - Wpadding * 2
	If Value = Wvalues(i) Then
		IntSetByIndex(i)
		Return
	End If
	Next
End Sub

Sub ReadWheel As String
	Return Wvalues(newposition/Wwheelstep + Wpadding -1)
End Sub

Sub ReadIndex As Int 
	'External Index base is 1
	Return (newposition/Wwheelstep)
End Sub

Sub ReadPosition As Int 'temp
	Return newposition
End Sub

' Sets the background color of the wheel.
Sub SetColor(color As Int)
	Wlblcolor = color
	putlabels(Wvalues.Length)
End Sub

' Sets the text color of the wheel.
Sub SetTextColor(color As Int)
	Wtextcolor = color
	putlabels(Wvalues.Length)
End Sub

' Sets the text size of the wheel.
Sub SetTextSize(size As Int)
	Wtextsize = size
	putlabels(Wvalues.Length)
End Sub

' Sets the gravity of the wheel (use left , center or right)
Sub SetGravity(Gr As Int)
	Wlblgravity = Gr
	putlabels(Wvalues.Length)
End Sub

' Sets several appearance parameters of the wheel.
Sub SetAppearance(labelcolor As Int, textcolor As Int, textsize As Int, lblgravity As Int)
	Wlblcolor = labelcolor
	Wtextcolor = textcolor
	Wtextsize = textsize
	Wlblgravity = lblgravity
	putlabels(Wvalues.Length)
End Sub

' Sets the delay in ms until the wheel settles.
Sub SetDelay(Delay As Int) 
	Wdelay = Delay
	tmr.Interval = Wdelay
End Sub

'Set the wheel to Bottom or Top of the list.
Sub FullScroll(Bottom As Boolean)
	sv.FullScroll(Bottom)
	tmr.Enabled = True
End Sub

' Update the list of values of the wheel, using a list.
Sub UpdateList( List1 As List )
	SetValuesByList(List1)
	Reset
End Sub

' Update the list of values of the wheel, using a string array.
Sub UpdateArray(values() As String)
	SetValuesByArray(values)
	Reset	
End Sub

' Update the list of values of the wheel, using a string array of two numbers - first and last.
Sub UpdateInt(First As Int, Last As Int)
	SetValuesByInt(First,Last)
	Reset
End Sub

Sub SetCover(dir As String, filename As String)
	overlay.SetBackgroundImage(LoadBitmap(dir , filename))
End Sub

Private Sub Reset
	Dim n As Int
	n = Wvalues.Length
	WHeight = (n+2) * Wwheelstep 
	sv.panel.Height = WHeight
	putlabels( n) 
End Sub

Private Sub sv_ScrollChanged(Position As Int)
	Dim y As Double
	y = Position
	If Wcyclic Then
		If Position > WHeight - (Wpadding * 2 + 1.4) * Wwheelstep Then
		 	newposition =  0.6 * Wwheelstep 'near first position
			sv.ScrollPosition = newposition
		Else 
		  If Position <  0.6 * Wwheelstep Then
		   	newposition = WHeight - (Wpadding * 2 + 1.6) * Wwheelstep 'near last position
		  	sv.ScrollPosition = newposition
	    Else 
			  newposition = Wwheelstep * Floor(y/Wwheelstep + 0.5)
		  End If
	  End If
	Else
	  If Position > WHeight - (Wpadding * 2 + 1.4) * Wwheelstep Then
		 	newposition = WHeight - (Wpadding * 2 + 2) * Wwheelstep 'jump back
		  'sv.ScrollPosition = newposition
		Else 
		  If Position < 0.6 * Wwheelstep Then
		   	newposition = Wwheelstep 'jump up
		  	'sv.ScrollPosition = newposition
			Else
	      newposition = Wwheelstep * Floor(y/Wwheelstep + 0.5)
			End If
		End If
	End If
	' this event can be included but is not needed for just reading the wheel.
	'If  SubExists( Wmodule, WEventName & "_ScrollChanged") Then
	'	CallSub2(Wmodule, WEventName  & "_ScrollChanged", Position)				
	'End If				
	tmr.Enabled = True
End Sub

Private Sub tmr_tick
	sv.ScrollPosition = newposition
	tmr.Enabled =  False
	If SubExists(Wmodule, WEventName & "_Roll") Then
	  CallSub2(Wmodule,WEventName & "_Roll", ReadWheel)	
	End If
End Sub